		CODE32

		AREA n2gold, CODE, READONLY
	  
SCR_WIDTH	EQU	160
SCR_HEIGHT	EQU 152
FBUFPOS	EQU	38400 ; 80*240*2
FBUFY	EQU 392	; (152+44)*2


  MACRO
  readWrite2pixels
  
  ldr		r2, [r1], #4
	mov		r5, r2, lsr #16

	; 4:4:4 BGR -&gt; 5:5:5:1 RGB
	;

	and		r3, r2, #0x00f0
	and		r4, r2, #0x0f00
	mov		r2, r2, lsl #12		;Decalage des quatres bits R
	orr		r2, r2, r4, lsr #6  ;Insertion de Blue
	orr		r2, r2, r3, lsl #3	;Insertion de G

	orr     r2, r2, r10;		;Luminosit

	strh	r2, [r0], r8

	and		r3, r5, #0x00f0
  and		r4, r5, #0x0f00
	mov		r5, r5, lsl #12
  orr		r5, r5, r4, lsr #6
	orr		r5, r5, r3, lsl #3

	orr     r5, r5, r10;		;Augmente luminosit
	
	strh	r5, [r0], r8 
  
  MEND
  
  
; definition dans source C	     
; void n2g(unsigned short *map,unsigned int *cfb);
;
; Parameters:
;   r0 = pointer vers ecran
;   r1 = pointer cfb (ecran ngp)
;
; Returns:
;   none
;

	ENTRY
	
	EXPORT n2gold

;n2gold
	stmdb   sp!,{r4-r10,lr}

;		ldr		r9, =(SCR_WIDTH*240*2)+2
;		ldr		r9, =(SCR_WIDTH*480)+2
;		ldr		r9, =76802
		mov		r9, 	#0x12C00
		orr		r9, r9, #0x00002
		
		
		mov		r8, #480

		;mov		r0,r0, #0x0C700000
		;orr		r0,r0, #0x000B4000
		

		add		r0, r0, #FBUFPOS
		add		r0, r0, #FBUFY		; r0 = upper left corner
		mov		r7, #SCR_HEIGHT

		mov		r10,#0x840			;Luminosit  #843
		
AAA	
    mov		r6, #2		; two pixels at a time

BBB	
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
		readWrite2pixels
    readWrite2pixels
    
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
		readWrite2pixels
    readWrite2pixels
    
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
		readWrite2pixels
    readWrite2pixels
    
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
    readWrite2pixels
		readWrite2pixels
    readWrite2pixels
    
 	  subs	r6, r6, #1

    bne		BBB
		subs  r7, r7, #1
		sub		r0, r0, r9
		bne		AAA

		ldmia	sp!, {r4-r10,pc}

;############################################"

  MACRO
  trans8pix
  
  ;//Prendre 8 pixels d'un coup
  ldmia		r1!,{r4-r7}
  
  and		r3,r12,r4,lsl#1
  ldrh		r3,[r2,r3]
  strh		r3,[r0],r8
  and		r3,r12,r4,lsr#15
  ldrh		r3,[r2,r3]
  strh		r3,[r0],r8
  
  and		r3,r12,r5,lsl#1
  ldrh		r3,[r2,r3]
  strh		r3,[r0],r8
  and		r3,r12,r5,lsr#15
  ldrh		r3,[r2,r3]
  strh		r3,[r0],r8

  and		r3,r12,r6,lsl#1
  ldrh		r3,[r2,r3]
  strh		r3,[r0],r8
  and		r3,r12,r6,lsr#15
  ldrh		r3,[r2,r3]
  strh		r3,[r0],r8

  and		r3,r12,r7,lsl#1
  ldrh		r3,[r2,r3]
  strh		r3,[r0],r8
  and		r3,r12,r7,lsr#15
  ldrh		r3,[r2,r3]
  strh		r3,[r0],r8
  
  MEND
  
  
; definition dans source C	     
; void n2gt(unsigned short *map,unsigned int *cfb,unsigned short* colormap );
;
; Parameters:
;   r0 = pointer vers ecran
;   r1 = pointer cfb (ecran ngp)
;   r2 = pointer color map
;
; Returns:
;   none
;


n2gt
	EXPORT n2gt

	stmdb   sp!,{r4-r12,lr}

	ldr		r9, =(SCR_WIDTH*240*2)+2
;	ldr		r9, =(SCR_WIDTH*480)+2
;	ldr		r9, =76802
	mov		r8, #480

	;mov	r0,r0, #0x0C700000
	;orr	r0,r0, #0x000B4000
	
	add		r0, r0, #FBUFPOS
	add		r0, r0, #FBUFY		; r0 = upper left corner
	mov		r11, #SCR_HEIGHT
	;mov		r11,r11,lsl#2	;*4

	mov		r12,#0xFE
	orr		r12,r12,#0x1F00
		
loop	
;	mov		r10,#4
;loop2
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	trans8pix
	
;	subs  	r10, r10, #1
;	bne		loop2
    
	sub		r0, r0, r9
	subs  	r11, r11, #1
	bne		loop

	;//return
	ldmia	sp!, {r4-r12,pc}

;############################################"

	EXPORT n2gtfree

n2gtfree

	stmdb   sp!,{r4-r12,lr}
	
	;// Poke
	;
	;Dans R0, pointeur du screen de la NEOGEO
	;dans R1, la rsolution X
	;dans R2, la rsolution Y
	
	;ECRAN GP32  = 0x25800 octets / 2 bytes per pixel RRRRRGGGGGBBBBBI
	;DEBUT ECRAN = 0x0C7B4000
	;FIN ECRAN   = 0x0C7D9800

	; r10=Calcul offset ecran mmoire
	mov		r10,    #0x0C700000    
	add		r10,r10,#0x000B4000    
    
	; r11=Calcul offset cran X
	mov		r11, #320
    sub		r11, r11, r1
    bic		r11,r11,#1
    mov		r14,#240
    mul		r11, r11, r14
	add		r10,r10,r11
	    
	; r11=Calcul offset cran Y
	mov		r11, #240
	sub		r11, r11, r2
    bic		r11,r11,#1
	add		r10,r10,r11
	
	;Derniere ligne source
	add		r0,r0,#0xBC00
	add		r0,r0,#0x00C0
	
	;Incrementeur de colonne DST
    mov		r12,#480
    
    ; r6=boucle Y
	add		r6, r2, #1

    ;r4 = Init Bresenham Y
    mov		r4, r2, lsr#1

BCLY	
	subs	r6,r6,#1
	beq		BCLY2

	;r3 = Init Bresenham X
    mov		r3, r1, lsr#1
    ;r1 = boucle X
   	add		r5, r1, #1
   	mov		r11,r10	;sauvegarde r10
BCLX	
	subs	r5,r5,#1
	beq		BCLX2	;boucle en avant pour RISC DefStepForward

	ldrh	r9,[r0]
	and		r8,r9,#0xF00
	and		r7,r9,#0x0F0
	mov		r9,r9,lsl#12
	orr		r9,r9,r8,lsr#6  ;Insertion de Blue
	orr		r9,r9,r7,lsl#3	 ;Insertion de G
	orr		r9,r9,#0x840			;Luminosit  #843
	orr		r9,r9,#0x003
	strh	r9,[r10],r12
	
	; bresenham X
	subs	r3,r3,#160
	addmi	r3,r3,r1
	addmi	r0,r0,#2			;Passer a la colonne suivante
	b		BCLX
BCLX2	

	mov		r10,r11
	add		r10,r10,#2
	sub		r0,r0,#320		;repositionnement source
	
	; bresenham Y
	subs	r4,r4,#152
	addmi	r4,r4,r2
	submi	r0,r0,#320		;prochaine ligne source
	b		BCLY
	
BCLY2	

	ldmia	sp!, {r4-r12,pc}


; ###########################################################


	EXPORT n2gfree

n2gfree

	stmdb   sp!,{r4-r12,lr}
	
	;// Poke
	;
	;Dans R0, pointeur du screen de la NEOGEO
	;dans R1, la rsolution X
	;dans R2, la rsolution Y
	
	;ECRAN GP32  = 0x25800 octets / 2 bytes per pixel RRRRRGGGGGBBBBBI
	;DEBUT ECRAN = 0x0C7B4000
	;FIN ECRAN   = 0x0C7D9800

	; r10=Calcul offset ecran mmoire
	mov		r10,    #0x0C700000    
	add		r10,r10,#0x000B4000    
    
	; r11=Calcul offset cran X
	mov		r11, #320
    sub		r11, r11, r1
    bic		r11,r11,#1
    mov		r14,#240
    mul		r11, r11, r14
	add		r10,r10,r11
	    
	; r11=Calcul offset cran Y
	mov		r11, #240
	sub		r11, r11, r2
    bic		r11,r11,#1
	add		r10,r10,r11
	
	;Derniere ligne source
	add		r0,r0,#0xBC00
	add		r0,r0,#0x00C0
	
	;Incrementeur de colonne DST
    mov		r12,#480
    
    ; r6=boucle Y
	add		r6, r2, #1

    ;r4 = Init Bresenham Y
    mov		r4, r2, lsr#1

TBCLY	
	subs	r6,r6,#1
	beq		TBCLY2

	;r3 = Init Bresenham X
    mov		r3, r1, lsr#1
    ;r1 = boucle X
   	add		r5, r1, #1
   	mov		r11,r10	;sauvegarde r10
TBCLX	
	subs	r5,r5,#1
	beq		TBCLX2	;boucle en avant pour RISC DefStepForward

	ldrh	r9,[r0]
	and		r8,r9,#0xF00
	and		r7,r9,#0x0F0
	mov		r9,r9,lsl#12
	orr		r9,r9,r8,lsr#6  ;Insertion de Blue
	orr		r9,r9,r7,lsl#3	 ;Insertion de G
	orr		r9,r9,#0x840			;Luminosit  #843
	orr		r9,r9,#0x003
	strh	r9,[r10],r12
	
	; bresenham X
	subs	r3,r3,#160
	addmi	r3,r3,r1
	addmi	r0,r0,#2			;Passer a la colonne suivante
	b		TBCLX
TBCLX2	

	mov		r10,r11
	add		r10,r10,#2
	sub		r0,r0,#320		;repositionnement source
	
	; bresenham Y
	subs	r4,r4,#152
	addmi	r4,r4,r2
	submi	r0,r0,#320		;prochaine ligne source
	b		TBCLY
	
TBCLY2	

	ldmia	sp!, {r4-r12,pc}


	END