
// -------------------- Pico Library --------------------

// Pico Library - Header File

// All code (c) Copyright 2004 Dave, All rights reserved.
// Free for non-commercial use.

// For commercial use, separate licencing terms must be obtained.

#ifdef __cplusplus
extern "C" {
#endif

// Pico.cpp
extern int PicoVer;
int PicoInit();
void PicoExit();
int PicoFrame();
int PicoReset();
extern int PicoPad[2]; // Joypads, format is SACB RLDU

// Cart.cpp
int PicoCartLoad(FILE *f,unsigned char **prom,unsigned int *psize);
int PicoCartInsert(unsigned char *rom,unsigned int romsize);

// Draw.cpp
extern int (*PicoScan)(unsigned int num,unsigned short *data);

// Sek.cpp
extern char PicoStatus[];

#ifdef __cplusplus
} // End of extern "C"
#endif
